/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2001 Sun Microsystems, Inc. Used by permission.
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation version 2 of the License.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 * END COPYRIGHT BLOCK **/

package com.netscape.admin.dirserv.panel;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.io.File;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;
import com.netscape.admin.dirserv.*;
import com.netscape.management.client.*;
import com.netscape.management.client.util.AbstractDialog;
import com.netscape.management.client.util.Debug;
import com.netscape.management.client.util.*;
import netscape.ldap.*;
import netscape.ldap.util.DN;
import com.netscape.management.nmclf.SuiConstants;


/**
 * Panel for Directory Server resource page
 *
 * @author  rmarco
 * @version %I%, %G%
 * @date	 	9/15/97
 * @see     com.netscape.admin.dirserv
 */
public class ChainingInstanceAuthPanel extends BlankPanel 
    implements  SuiConstants{
     
    public ChainingInstanceAuthPanel(IDSModel model,
				     LDAPEntry InstEntry ) {
	//		super( model, _section, true );
	super( model, _section);
	_helpToken = "configuration-chaining-authentication-help";
	_dnEntry = InstEntry.getDN();
	_chEntry = InstEntry;
	_model = model;
	_refreshWhenSelect = false;
	}

	public void init() {
		if (_isInitialized) {
			return;
		}
		_myPanel.setLayout( new GridBagLayout() );
		GridBagConstraints gbc = getGBC();
		gbc.gridx      = 0;
		gbc.gridy      = 0;
		linkData();		
		createAuthArea( _myPanel);
		createComment( _myPanel );
		checkComment();
		addBottomGlue();		
		_isInitialized = true;
	}


	private void createComment( JPanel  grid ) {

		GridBagConstraints ugbc = getGBC(); 
		JPanel panel = 
			new GroupPanel(DSUtil._resource.getString( _section,
													   "proxy-help-title" ),
						   true);
		
		ugbc.gridy= 1;ugbc.gridx = 0;
        ugbc.gridwidth = ugbc.REMAINDER;
		ugbc.fill = ugbc.BOTH;		
		grid.add( panel, ugbc );		

		GridBagConstraints pgbc = new GridBagConstraints();
        pgbc.gridx      = 0;
        pgbc.gridy      = 0;
        pgbc.gridwidth	 = 1;
        pgbc.gridheight = 1;
        pgbc.weightx    = 1;
        pgbc.weighty    = 1;
        pgbc.fill       = pgbc.BOTH;
        pgbc.anchor     = pgbc.CENTER;
        pgbc.insets     = new Insets(DEFAULT_PADDING,DEFAULT_PADDING,
									0,DEFAULT_PADDING);
        pgbc.ipadx = 0;
        pgbc.ipady = 0;

		_lcomment = makeJLabel( _section,
								"proxy-help-comment" );
		_lcomment.setLabelFor(panel);
		pgbc.gridx  = 0;
		pgbc.anchor = pgbc.WEST; 
		pgbc.fill = pgbc.HORIZONTAL;
		pgbc.gridwidth  = pgbc.REMAINDER;
		panel.add( _lcomment, pgbc);

		_lcommentUsrLabel= makeJLabel( _section,
									   "proxy-help-user" );
		_lcommentUsr = new JLabel();
		_lcommentUsrLabel.setLabelFor(_lcommentUsr);
		pgbc.gridy++;
		pgbc.gridx      = 0;
		pgbc.fill = pgbc.NONE;
		pgbc.gridwidth  = 1;
		pgbc.weightx    = 0;
		pgbc.anchor = pgbc.EAST;
		panel.add( _lcommentUsrLabel, pgbc);

		pgbc.gridx  = 1;
		pgbc.anchor = pgbc.WEST; 
		pgbc.fill = pgbc.HORIZONTAL;
		pgbc.weightx    = 1;
		pgbc.gridwidth  = pgbc.REMAINDER;
		panel.add( _lcommentUsr, pgbc);


		_lcommentNcLabel = makeJLabel( _section,
									   "proxy-help-naming-context" );
		_lcommentNc = new JLabel();
		_lcommentNcLabel.setLabelFor(_lcommentNc);

		pgbc.gridx      = 0;
		pgbc.gridy++;
		pgbc.fill = pgbc.NONE;
		pgbc.gridwidth  = 1;
		pgbc.weightx    = 0;
		pgbc.anchor = pgbc.EAST;
		panel.add( _lcommentNcLabel, pgbc);

		pgbc.gridx  = 1;
		pgbc.anchor = pgbc.WEST; 
		pgbc.fill = pgbc.HORIZONTAL;
		pgbc.weightx    = 1;
		pgbc.gridwidth  = pgbc.REMAINDER;
		panel.add( _lcommentNc, pgbc);

		_lcommentAciLabel = makeJLabel( _section,
										"proxy-help-aci" );
		_lcommentAci = new JLabel();

		_tfaCommentAci = new JTextArea( 3, 10);
		_lcommentAciLabel.setLabelFor(_tfaCommentAci);
		_tfaCommentAci.setWrapStyleWord( true );
		_tfaCommentAci.setEditable( false );
		_tfaCommentAci.setBackground(Color.lightGray);

		pgbc.gridy++;
		pgbc.gridx      = 0;
		pgbc.weightx    = 0;
		pgbc.fill = pgbc.NONE;
		pgbc.gridwidth  = 1;
		pgbc.anchor = pgbc.NORTHEAST;
		panel.add( _lcommentAciLabel, pgbc);
		
		


		JScrollPane scrollBck = new JScrollPane();
		scrollBck.getViewport().setView(_tfaCommentAci); 
		pgbc.gridx  = 1;
		pgbc.anchor = pgbc.WEST; 
		pgbc.weightx    = 0;
		pgbc.fill = pgbc.HORIZONTAL;
		pgbc.gridwidth  = pgbc.REMAINDER;
		panel.add( scrollBck, pgbc);
		//
		// panel.add( _tfaCommentAci, pgbc);
		//
		
	}

	private void createAuthArea( JPanel  grid ) {

		GridBagConstraints ugbc = getGBC(); 
		JPanel panel = new JPanel( new GridBagLayout() );
		ugbc.gridy= 0;ugbc.gridx = 0;
        ugbc.gridwidth = ugbc.REMAINDER;
		ugbc.fill = ugbc.HORIZONTAL;		
		grid.add( panel, ugbc );		

		GridBagConstraints pgbc = new GridBagConstraints();
        pgbc.gridx      = 0;
        pgbc.gridy      = 0;
        pgbc.gridwidth	 = 1;
        pgbc.gridheight = 1;
        pgbc.weightx    = 1;
        pgbc.weighty    = 1;
        pgbc.fill       = pgbc.BOTH;
        pgbc.anchor     = pgbc.CENTER;
        pgbc.insets     = new Insets(DEFAULT_PADDING,DEFAULT_PADDING,
									0,DEFAULT_PADDING);
        pgbc.ipadx = 0;
        pgbc.ipady = 0;	

		pgbc.gridx      = 0;
		pgbc.fill = pgbc.NONE;
		pgbc.weightx    = 0;
		pgbc.anchor = pgbc.EAST;
		panel.add( _lSuffixLabel, pgbc);

		pgbc.gridx  = 1;
		pgbc.anchor = pgbc.WEST;
		pgbc.weightx    = 1;
		panel.add( _lSuffixText, pgbc);


		pgbc.gridy++;
        pgbc.gridx = 0;
		addEntryField( panel,
					   pgbc,
					   _lnsfarmserverurl,
					   _tfnsfarmserverurl);

		pgbc.gridy++;
        pgbc.gridx = 0;
		addEntryField( panel,
					   pgbc,
					   _lnsmultiplexorbinddn,
		 			   _tfnsmultiplexorbinddn );

		pgbc.gridy++;
        pgbc.gridx = 0;
		addEntryField( panel,
					   pgbc,
					   _lnsmultiplexorcredentials,
					   _pfnsmultiplexorcredentials );
		
		pgbc.gridy++;
        pgbc.gridx = 0;
		pgbc.insets     = new Insets(DEFAULT_PADDING,DEFAULT_PADDING,
									 DEFAULT_PADDING,DEFAULT_PADDING);
		addEntryField( panel,
					   pgbc,
					   _lConfirmPassword,
					   _pfConfirmPassword );
		

	}



    protected void addEntryField( JPanel panel, 
								  GridBagConstraints gbc,
								  JComponent label,
								  JComponent field, 
								  JLabel label2 ) {
		Component endGlue = STRETCH_FIELDS ? null : Box.createGlue();
		Component lastItem =
			STRETCH_FIELDS ? ((label2 != null) ? label2 : field) : endGlue;
		gbc.fill = gbc.NONE;
		gbc.weightx = 0.0;
        gbc.gridwidth = 1;
		//		gbc.gridx = 0;
		gbc.anchor = gbc.EAST;
		int space = UIFactory.getComponentSpace();
		gbc.insets = new Insets( space, space, 0, space/2 );
		panel.add( label, gbc );

		gbc.gridx++;
		gbc.anchor = gbc.WEST;
		gbc.insets = new Insets( space, 0, 0, 0 );
		if ( STRETCH_FIELDS ) {
			gbc.fill = gbc.HORIZONTAL;
			gbc.weightx = 1.0;
		}
		gbc.gridwidth = (lastItem == field) ? gbc.REMAINDER : 1;
		panel.add( field, gbc );

		if ( label2 != null ) {
			gbc.gridx++;
			gbc.fill = gbc.NONE;
			gbc.weightx = 0.0;
			gbc.insets = new Insets( space, space/2, 0, 0 );
			gbc.gridwidth = (lastItem == label2) ? gbc.REMAINDER : 1;
			panel.add( label2, gbc );
		}

		if ( !STRETCH_FIELDS ) {
			gbc.gridx++;
			gbc.anchor = gbc.EAST;
			gbc.fill = gbc.HORIZONTAL;
			gbc.weightx = 1.0;
			gbc.gridwidth = gbc.REMAINDER;
			panel.add( endGlue, gbc );
		}
	}

    /**
	 * Add a label and a textfield to a panel, assumed to be using
	 * GridBagLayout.
	 */
    protected void addEntryField( JPanel panel,
								  GridBagConstraints gbc,
								  JComponent label,
								  JComponent field ) {
		addEntryField( panel, gbc, label, field, null );
	}

	private void linkData() {


		_lSuffixLabel =  makeJLabel( _section, "suffix" );
		
		_lSuffixText =  new JLabel();
		if ( _chEntry.getAttribute( SUFFIX_ATTR_NAM ) != null ) {
			_lSuffixText.setText(
					_chEntry.getAttribute( SUFFIX_ATTR_NAM ).getStringValueArray()[0]);
		} else {
			_lSuffixText.setText( SUFFIX_ATTR_NULL );
		}

		entries = new DSEntrySet( false );
		setDSEntrySet( entries );

		/* nsmultiplexorbinddn */
		_tfnsmultiplexorbinddn = makeJTextField( _section,
												 "nsmultiplexorbinddn" );
		_lnsmultiplexorbinddn = makeJLabel( _section,
											"nsmultiplexorbinddn" );
		_lnsmultiplexorbinddn.setLabelFor(_tfnsmultiplexorbinddn);

		LDAPAttribute binddn = 
			_chEntry.getAttribute( NSMULTIPLEXORBINDDN_ATTR );
		_isBindDNExist = ( binddn != null );

		DSEntryDN _nsmultiplexorbinddn = 
			new DSEntryDN("",
						  _tfnsmultiplexorbinddn,
						  _lnsmultiplexorbinddn,
						  NSMULTIPLEXORBINDDN_ATTR,
						  _model );
		entries.add( _dnEntry,
					 NSMULTIPLEXORBINDDN_ATTR,
					 _nsmultiplexorbinddn );
		setComponentTable( _tfnsmultiplexorbinddn,
						   _nsmultiplexorbinddn );

		/* nsmultiplexorcredentials */
		_pfnsmultiplexorcredentials = makeJPasswordField(20 );
		_lnsmultiplexorcredentials =
			makeJLabel( _section,
						"nsmultiplexorcredentials" );
		_lnsmultiplexorcredentials.setLabelFor(_pfnsmultiplexorcredentials);
		/* nsmultiplexorcredentials confirmation */
		_pfConfirmPassword = makeJPasswordField(20 );
		_lConfirmPassword =
			makeJLabel( _section,
						"confirmcredentials" );
		_lConfirmPassword.setLabelFor(_pfConfirmPassword);
		LDAPAttribute passwd = 
			_chEntry.getAttribute( NSMULTIPLEXORCREDENTIALS_ATTR );
		_isPasswdExist = ( passwd != null );
		DSEntryConfirmPassword dsEntryConfirm =
			new DSEntryConfirmPassword("",
									   _pfConfirmPassword,
									   _lConfirmPassword,
									   _pfnsmultiplexorcredentials,
									   1);
		setComponentTable(_pfConfirmPassword, dsEntryConfirm);
		
		DSEntryPassword dsEntryPwd =
			new DSEntryPassword("",
								_pfnsmultiplexorcredentials,
								_lnsmultiplexorcredentials,
								dsEntryConfirm,
								1);
		setComponentTable(_pfConfirmPassword, dsEntryPwd);
		entries.add(_dnEntry,
					NSMULTIPLEXORCREDENTIALS_ATTR,
					dsEntryPwd);		

		/* nsfarmserverurl */
		_tfnsfarmserverurl = makeJTextField( _section,
												 "nsfarmserverurl" );
		_lnsfarmserverurl = makeJLabel( _section,
											"nsfarmserverurl" );
		_lnsfarmserverurl.setLabelFor(_tfnsfarmserverurl);
		DSEntryText _nsfarmserverurl = 
			new DSEntryText("",
							_tfnsfarmserverurl,
							_lnsfarmserverurl );
		entries.add( _dnEntry,
					 NSFARMSERVERURL_ATTR,
					 _nsfarmserverurl );
		setComponentTable( _tfnsfarmserverurl,
						   _nsfarmserverurl );

		entrybind = getAttrVal( NSMULTIPLEXORBINDDN_ATTR );
		entrypwd  = getAttrVal( NSMULTIPLEXORCREDENTIALS_ATTR );
		entryurl  = getAttrVal( NSFARMSERVERURL_ATTR );

	}

	private void checkComment() {
		String usr = _tfnsmultiplexorbinddn.getText();
		String suf = _chEntry.getAttribute( SUFFIX_ATTR_NAM ).getStringValueArray()[0];
		String aci = "(targetattr = \"*\")" + 
			"(version 3.0; acl \"proxy acl\"; " +
			"allow(proxy) userdn=\"ldap:///" +
			usr + "\";)";


		_lcommentNc.setText( suf );
		_lcommentUsr.setText( usr);
		_tfaCommentAci.setText( aci );

	}

    public void changedUpdate(DocumentEvent e) {
		super.changedUpdate( e );
		if((e.getDocument() ==
			_pfnsmultiplexorcredentials.getDocument()) ||
		   (e.getDocument() ==
			_pfConfirmPassword.getDocument())) {
			_isPasswdExist = true;
		}
		modelUpdate();		
	}

    public void insertUpdate(DocumentEvent e) {
		super.changedUpdate( e );
		modelUpdate();
	}
    public void removeUpdate(DocumentEvent e) {
		super.removeUpdate( e );
		modelUpdate();
	}

	private void modelUpdate(){
		checkValues();
		checkOkay();
		checkComment();
	}

	private void checkValues() {
		
		_isBindDNValid = DN.isDN( _tfnsmultiplexorbinddn.getText());

		if( entrybind == null ) {
			_isBindDNDirty = ( _tfnsmultiplexorbinddn.getText().trim().length() != 0);
		} else {
			_isBindDNDirty = (entrybind.compareTo( _tfnsmultiplexorbinddn.getText()) != 0 );
		}

		if(_isBindDNValid){
			if(_isBindDNDirty){
				setChangeState( _lnsmultiplexorbinddn, CHANGE_STATE_MODIFIED );
			} else {
				setChangeState( _lnsmultiplexorbinddn, CHANGE_STATE_UNMODIFIED );
			}
		} else {
			setChangeState( _lnsmultiplexorbinddn,
					  CHANGE_STATE_ERROR);
		}
				   
		String pwd = new String( _pfnsmultiplexorcredentials.getPassword());
		String confpwd = new String( _pfConfirmPassword.getPassword());
		_isPasswdValid = ( pwd.compareTo( confpwd ) == 0);
		if ( entrypwd == null ) {
			_isPasswdDirty = (pwd.trim().compareTo("") != 0);
		} else {
			_isPasswdDirty = (entrypwd.compareTo( pwd ) != 0);
		}
		
		if(_isPasswdValid) {
			if ( _isPasswdDirty ){
				setChangeState( _lnsmultiplexorcredentials,
						  CHANGE_STATE_MODIFIED);
				setChangeState( _lConfirmPassword,
						  CHANGE_STATE_MODIFIED);			
			} else {
				setChangeState( _lnsmultiplexorcredentials,
						  CHANGE_STATE_UNMODIFIED );
				setChangeState( _lConfirmPassword,
						  CHANGE_STATE_UNMODIFIED );			
			}	
		} else {
			setChangeState( _lnsmultiplexorcredentials,
					  CHANGE_STATE_ERROR);
			setChangeState( _lConfirmPassword,
					  CHANGE_STATE_ERROR);
		}

		_isURLDirty = (entryurl.compareTo( _tfnsfarmserverurl.getText()) != 0);
		_isURLValid = valideChainingURL( _tfnsfarmserverurl.getText() );
		if(_isURLValid){
			if(_isURLDirty) {
				setChangeState( _lnsfarmserverurl,
						  CHANGE_STATE_MODIFIED);
			} else {
				setChangeState( _lnsfarmserverurl,
						  CHANGE_STATE_UNMODIFIED );
			}
		} else {
			setChangeState( _lnsfarmserverurl,
					  CHANGE_STATE_ERROR);
		}
	}

	public boolean valideChainingURL( String url ){
		boolean ok;
		if(( url == null) || (url.length() == 0)){
			return false;
		}
		ok = ( url.startsWith("ldap://") || url.startsWith("ldaps://") );
		ok = ok && ( url.endsWith("/"));
		return( ok );
	}

	/**
	 * Enable/disable OK button
	 *
	 * @param ok true to enable the OK button
	 */
    private void setOkay( boolean ok ) {
		if( ok ) {
			setValidFlag();
		} else {
			clearValidFlag();
		}
	}

	private String getAttrVal( String attrName ) {
		if ( _chEntry != null ) {
			LDAPAttribute attr = _chEntry.getAttribute( attrName );
			if ( attr != null ) {
				Enumeration en = attr.getStringValues();
				if ( (en != null) && en.hasMoreElements() )
					return (String)en.nextElement();
			}
		}
		return null;
    }
			  
	private void checkDirtyFlag(){
		boolean dirty =  _isBindDNDirty || _isPasswdDirty || _isURLDirty;		
		if ( dirty ) {
			setDirtyFlag();	
		} else {
			clearDirtyFlag();
		}		
	}
									  
    private void checkOkay() {
		boolean ok = (_isBindDNValid && _isPasswdValid && _isURLValid );
		checkDirtyFlag();
		setOkay( ok);
	}
			

	public void okCallback() {
		LDAPConnection ldc = _model.getServerInfo().getLDAPConnection();
		if( _isBindDNDirty){
			String bindn = _tfnsmultiplexorbinddn.getText();
			String bindnL[] = { bindn };
			boolean deleted = false;
			LDAPModificationSet attrs = new LDAPModificationSet();

			if(( bindn == null) ||
			   ( bindn.length() == 0)) {
				deleted = true;
				attrs.add(LDAPModification.DELETE,
						  new LDAPAttribute(NSMULTIPLEXORBINDDN_ATTR));
						  
			} else  if( ! _isBindDNExist) {
				attrs.add(LDAPModification.ADD,
						  new LDAPAttribute( NSMULTIPLEXORBINDDN_ATTR,
											 bindnL));
			} else {
				attrs.add(LDAPModification.REPLACE,
						  new LDAPAttribute( NSMULTIPLEXORBINDDN_ATTR,
											 bindnL));
			}
			try {
				ldc.modify( _chEntry.getDN(), attrs );
				clearDirtyFlag();
				_isBindDNDirty = false;
				_isBindDNExist = !deleted;
				entrybind = bindn;
				/*
				DSEntryDN _nsmultiplexorbinddn = 
					new DSEntryDN("",
								  _tfnsmultiplexorbinddn,
								  _lnsmultiplexorbinddn,
								  NSMULTIPLEXORBINDDN_ATTR,
								  _model );
				entries.add( _dnEntry,
							 NSMULTIPLEXORBINDDN_ATTR,
							 _nsmultiplexorbinddn );
				setComponentTable( _tfnsmultiplexorbinddn,
								   _nsmultiplexorbinddn );
				*/
			} catch (LDAPException e) {
				String[] args_m = { _chEntry.getDN(), e.toString() };
				DSUtil.showErrorDialog( getModel().getFrame(),
										"update-binddn-error",
										args_m,
										_section );
			}
		}

		if( _isPasswdDirty ){
			String pwd =  new String( _pfnsmultiplexorcredentials.getPassword());
			String pwdL[] = { pwd };
			boolean deleted = false;
			LDAPModificationSet attrs = new LDAPModificationSet();
			if (( pwd == null) || ( pwd.length() == 0)){
				deleted = true;
				attrs.add(LDAPModification.DELETE,
						  new LDAPAttribute( NSMULTIPLEXORCREDENTIALS_ATTR));
			} else if( !_isPasswdExist ) {
				attrs.add(LDAPModification.ADD,
						  new LDAPAttribute( NSMULTIPLEXORCREDENTIALS_ATTR, 
											 pwdL ));
			} else { 
				attrs.add(LDAPModification.REPLACE,
						  new LDAPAttribute( NSMULTIPLEXORCREDENTIALS_ATTR, 
											 pwdL ));
			}
			try {
				ldc.modify( _chEntry.getDN(), attrs );
				clearDirtyFlag();
				_isPasswdDirty = false;
				_isPasswdExist = ! deleted;
				entrypwd = pwd;
				/*
				DSEntryConfirmPassword dsEntryConfirm =
					new DSEntryConfirmPassword("",
											   _pfConfirmPassword,
											   _lConfirmPassword,
											   _pfnsmultiplexorcredentials,
											   1);
				setComponentTable(_pfConfirmPassword, dsEntryConfirm);
				
				DSEntryPassword dsEntryPwd =
					new DSEntryPassword("",
										_pfnsmultiplexorcredentials,
										_lnsmultiplexorcredentials,
										dsEntryConfirm,
										1);
				setComponentTable(_pfConfirmPassword, dsEntryPwd);
				entries.add(_dnEntry,
							NSMULTIPLEXORCREDENTIALS_ATTR,
							dsEntryPwd);				
							*/
			} catch (LDAPException e) {
				String[] args_m = { _chEntry.getDN(), e.toString() };
				DSUtil.showErrorDialog( getModel().getFrame(),
										"update-passwd-error",
										args_m,
										_section );				
				
			}
		}

		String url = _tfnsfarmserverurl.getText();
		String urlL[] = { url };
		if ( _isURLDirty ) {
			LDAPModificationSet attrs = new LDAPModificationSet();
			attrs.add(LDAPModification.REPLACE,
					  new LDAPAttribute( NSFARMSERVERURL_ATTR,
										 urlL ));
			try {
				ldc.modify( _chEntry.getDN(), attrs );
				clearDirtyFlag();
				_isURLDirty = false;
				_isURLValid = true;
				entryurl = url;
			} catch (LDAPException e) {
				String[] args_m = { _chEntry.getDN(), e.toString() };
				DSUtil.showErrorDialog( getModel().getFrame(),
										"update-passwd-error",
										args_m,
										_section );								
			}
			
		}
		//		super.okCallback();
	}
									  
	public void resetCallback() {
		_isPasswdDirty = false;
		if( ! _isBindDNExist ){	
			_tfnsmultiplexorbinddn.setText("");
		} 
		if( ! _isPasswdExist ){
			_pfnsmultiplexorcredentials.setText("");
			_pfConfirmPassword.setText("");
		} 
		super.resetCallback();
	}
									  
	private IDSModel			_model = null;
	private LDAPEntry			_chEntry = null;
	private String				_dnEntry;

	private JLabel				_lSuffixText;
	private JLabel				_lSuffixLabel;
	private JTextField			_tfnsmultiplexorbinddn;
	private JLabel				_lnsmultiplexorbinddn;
	private JPasswordField		_pfConfirmPassword;
	private JPasswordField		_pfnsmultiplexorcredentials;
	private JLabel				_lnsmultiplexorcredentials;
	private JLabel				_lConfirmPassword;					  
	private JTextField			_tfnsfarmserverurl;
	private JLabel				_lnsfarmserverurl;
	private JLabel				_lcomment;
	private JLabel				_lcommentNcLabel;
	private JLabel				_lcommentNc;
	private JLabel				_lcommentUsrLabel;
	private JLabel				_lcommentUsr;
	private JLabel				_lcommentAciLabel;
	private JLabel				_lcommentAci;
	private JTextArea			_tfaCommentAci;

	private boolean				_isPasswdExist;
	private boolean				_isBindDNExist;
	private boolean				_isPasswdValid = true;
	private boolean				_isBindDNValid = true;
	private boolean				_isPasswdDirty = false;
	private boolean				_isBindDNDirty = false;
	private boolean				_isURLValid = true;
	private boolean				_isURLDirty = false;

	private DSEntrySet			entries;
	
	private String				entrybind;
	private String				entrypwd;
	private String				entryurl;

								  
	private static final String _section = "chaining-instance-auth";
	private static final String NSMULTIPLEXORBINDDN_ATTR = 
										"nsmultiplexorbinddn";
	private static final String NSMULTIPLEXORCREDENTIALS_ATTR =
										"nsmultiplexorcredentials" ;
	private static final String NSFARMSERVERURL_ATTR = 
										"nsfarmserverurl";
	private static final String SUFFIX_ATTR_NAM= "nsslapd-suffix";
	private static final String SUFFIX_ATTR_NULL="";

									  
	  
    //copy from BlankPanel
    final static int DEFAULT_PADDING = 6;
    final static Insets DEFAULT_EMPTY_INSETS = new Insets(0,0,0,0);
    final static Insets BOTTOM_INSETS = new Insets(6,6,6,6);
}

